SystemOrganization addCategory: #'Graph-Tests'!
SystemOrganization addCategory: #'Graph-Extended'!
SystemOrganization addCategory: #'Graph-Core'!
SystemOrganization addCategory: #'Graph-Graphics'!
SystemOrganization addCategory: #'Graph-DolphinPort'!
SystemOrganization addCategory: #'Graph-Stochastic'!
SystemOrganization addCategory: #'Graph-StateMachine'!

TestCase subclass: #GraphTestCase
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

GraphTestCase subclass: #DirectionedGraphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

DirectionedGraphTestCase subclass: #DirectionedGraphBreathFirstDoTest
	instanceVariableNames: 'vertexVisitation edgeVisitation visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

DirectionedGraphBreathFirstDoTest subclass: #DirectionedGraphBackwardBreathFirstDoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!DirectionedGraphBackwardBreathFirstDoTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:29'!
isAbstract

	^false! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
setUp

	super setUp.
	visitor beBackwardGoing! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
test1

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).

	visitor step.
	self assertEquals: #('A') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'D' 'G' 'E') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'D' 'G' 'E' 'B' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'D' 'G' 'E' 'B' 'F' 'C' 'H') visitation: vertexVisitation! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
test2

	visitor currentVertices: (Array with: (graph vertexNamed: 'B')).

	visitor step.
	self assertEquals: #('B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'A') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'A' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'A' 'D' 'E' 'G') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'A' 'D' 'E' 'G' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'A' 'D' 'E' 'G' 'F' 'C' 'H') visitation: vertexVisitation! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
test3

	visitor currentVertices: (Array with: (graph vertexNamed: 'F')).

	visitor step.
	self assertEquals: #('F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'C' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'C' 'H' 'G' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'C' 'H' 'G' 'B' 'A' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'C' 'H' 'G' 'B' 'A' 'D' 'E') visitation: vertexVisitation.

! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
test4

	visitor currentVertices: (#('A' 'B' 'F') collect: [:each| graph vertexNamed: each]).

	visitor step.
	self assertEquals: #('A' 'B' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'F' 'D' 'C' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'F' 'D' 'C' 'H' 'E' 'G') visitation: vertexVisitation.! !

!DirectionedGraphBackwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:28'!
testRun

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).
	visitor run.

	self assertEquals: #('A' 'B' 'C' 'E' 'D' 'F' 'H' 'G') visitation: vertexVisitation! !

!DirectionedGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/20/2009 15:39'!
setUp

	super setUp.

	vertexVisitation := OrderedCollection new.
	edgeVisitation := OrderedCollection new.

	visitor := BreadthFirstGraphVisitor new.
	visitor vertexOperation: [:vertex| vertexVisitation add: (graph nameOf: vertex) ].
	visitor edgeOperation: [:edge| edgeVisitation add: edge ].! !

DirectionedGraphBreathFirstDoTest subclass: #DirectionedGraphForwardBreathFirstDoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!DirectionedGraphForwardBreathFirstDoTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:30'!
isAbstract

	^false! !

!DirectionedGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:29'!
test1

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).

	visitor step.
	self assertEquals: #('A') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'D' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'D' 'F' 'H' 'G') visitation: vertexVisitation! !

!DirectionedGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:29'!
test2

	visitor currentVertices: (Array with: (graph vertexNamed: 'B')).

	visitor step.
	self assertEquals: #('B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'C' 'E') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'C' 'E' 'D' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('B' 'C' 'E' 'D' 'F' 'G' 'H' 'A') visitation: vertexVisitation.! !

!DirectionedGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:29'!
test3

	visitor currentVertices: (Array with: (graph vertexNamed: 'F')).

	visitor step.
	self assertEquals: #('F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'E' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'E' 'H' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'E' 'H' 'D' 'A' 'G') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('F' 'E' 'H' 'D' 'A' 'G' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'E' 'H' 'D' 'A' 'G' 'B' 'C') visitation: vertexVisitation.! !

!DirectionedGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:29'!
test4

	visitor currentVertices: (#('A' 'B' 'F') collect: [:each| graph vertexNamed: each]).

	visitor step.
	self assertEquals: #('A' 'B' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'F' 'C' 'E' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'F' 'C' 'E' 'H' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'F' 'C' 'E' 'H' 'D' 'G') visitation: vertexVisitation.! !

!DirectionedGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:30'!
testRun

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).
	visitor run.

	self assertEquals: #('A' 'B' 'C' 'E' 'D' 'F' 'H' 'G') visitation: vertexVisitation! !

!DirectionedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:23'!
setUp

	super setUp.

	'ABCDEFGH' do: [:character| graph addVertex: Vertex new named: character asString ].
	#('AB' 'BC' 'BE' 'CF' 'FE' 'ED' 'DA' 'GH') 
		do: 
		[:each| graph connect: each first asString to: each second asString ].

	#('DG' 'FH')
		do:
		[:each| graph connect: each first asString and: each second asString ].! !

!DirectionedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:23'!
testConnectedComponents

	self assertEquals: 1 to: graph connectedComponents size! !

!DirectionedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:23'!
testConnection

	self deny:  ((graph vertexNamed: 'A') isConnectedTo: (graph vertexNamed: 'H')).
	self assert:  ((graph vertexNamed: 'E') isConnectedTo: (graph vertexNamed: 'F'))! !

!DirectionedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:23'!
testIsConnected

	self assert: graph isConnected! !

!DirectionedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:23'!
testIsTree

	self deny: graph isTree! !

GraphTestCase subclass: #DirectionlessGraphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

DirectionlessGraphTestCase subclass: #DirectionlessGraphBreathFirstDoTest
	instanceVariableNames: 'visitor vertexVisitation edgeVisitation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

DirectionlessGraphBreathFirstDoTest subclass: #DirectionlessGraphBackwardBreathFirstDoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!DirectionlessGraphBreathFirstDoTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
isAbstract

	^false! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/20/2009 15:39'!
setUp

	super setUp.

	vertexVisitation := OrderedCollection new.
	edgeVisitation := OrderedCollection new.

	visitor := BreadthFirstGraphVisitor new.
	visitor vertexOperation: [:vertex| vertexVisitation add: (graph nameOf: vertex) ].
	visitor edgeOperation: [:edge| edgeVisitation add: edge ].! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:31'!
test1

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).

	visitor step.
	self assertEquals: #('A') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('A' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:31'!
test2

	visitor currentVertices: (Array with: (graph vertexNamed: 'C')).

	visitor step.
	self assertEquals: #('C') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('C' 'B' 'G' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H' 'J' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H' 'J' 'N' 'O' 'K' 'L' 'P') visitation: vertexVisitation.
! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:31'!
test3

	visitor currentVertices: (Array with: (graph vertexNamed: 'F')).

	visitor step.
	self assertEquals: #('F') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('F' 'B' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M' 'N' 'O' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:31'!
test4

	visitor currentVertices: (Array with: (graph vertexNamed: 'H')).

	visitor step.
	self assertEquals: #('H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F' 'J' 'K' 'L') visitation: vertexVisitation.! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:31'!
test5

	visitor currentVertices: (Array with: (graph vertexNamed: 'N')).

	visitor step.
	self assertEquals: #('N') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F' 'J' 'K' 'L') visitation: vertexVisitation.! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
test6

	visitor currentVertices: (#('A' 'H') collect: [:name| graph vertexNamed: name]).

	visitor step.
	self assertEquals: #('A' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M' 'E' 'F' 'C' 'G' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M' 'E' 'F' 'C' 'G' 'N' 'O' 'J' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
testRun

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).
	visitor run.

	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O' 'P') visitation: vertexVisitation.! !

DirectionlessGraphBreathFirstDoTest subclass: #DirectionlessGraphForwardBreathFirstDoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:33'!
isAbstract

	^false! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
test1

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).

	visitor step.
	self assertEquals: #('A') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('A' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
test2

	visitor currentVertices: (Array with: (graph vertexNamed: 'C')).

	visitor step.
	self assertEquals: #('C') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('C' 'B' 'G' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H' 'J' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('C' 'B' 'G' 'D' 'A' 'E' 'F' 'M' 'H' 'J' 'N' 'O' 'K' 'L' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
test3

	visitor currentVertices: (Array with: (graph vertexNamed: 'F')).

	visitor step.
	self assertEquals: #('F') visitation: vertexVisitation.

	visitor step.
	self assertEquals:  #('F' 'B' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('F' 'B' 'J' 'A' 'E' 'C' 'K' 'L' 'G' 'D' 'H' 'M' 'N' 'O' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:32'!
test4

	visitor currentVertices: (Array with: (graph vertexNamed: 'H')).

	visitor step.
	self assertEquals: #('H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('H' 'D' 'M' 'C' 'G' 'N' 'O' 'P' 'B' 'A' 'E' 'F' 'J' 'K' 'L') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:33'!
test5

	visitor currentVertices: (Array with: (graph vertexNamed: 'N')).

	visitor step.
	self assertEquals: #('N') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F' 'J') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('N' 'M' 'G' 'H' 'O' 'P' 'C' 'D' 'B' 'A' 'E' 'F' 'J' 'K' 'L') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:33'!
test6

	visitor currentVertices: (#('A' 'H') collect: [:name| graph vertexNamed: name]).

	visitor step.
	self assertEquals: #('A' 'H') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M' 'E' 'F' 'C' 'G' 'N' 'O') visitation: vertexVisitation.

	visitor step.
	self assertEquals: #('A' 'H' 'B' 'D' 'M' 'E' 'F' 'C' 'G' 'N' 'O' 'J' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphForwardBreathFirstDoTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:33'!
testRun

	visitor currentVertices: (Array with: (graph vertexNamed: 'A')).
	visitor run.

	self assertEquals: #('A' 'B' 'C' 'E' 'F' 'D' 'G' 'J' 'K' 'L' 'M' 'H' 'N' 'O' 'P') visitation: vertexVisitation.! !

!DirectionlessGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
setUp

	super setUp.
	
	'ABCDEFGHJKLMNOP' do: [:each| graph addVertex: Vertex new named: (String with: each) ].
	#('AB' 'BC' 'CD' 'BE' 'BF' 'CG' 'DH' 'EJ' 'FJ' 'GM' 'HM' 'JK' 'JL' 'MN' 'MO' 'OP') 
		do: [:each| graph connect: each first asString and: each second asString ].! !

!DirectionlessGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
testConnectedComponents

	self assertEquals: 1 to: graph connectedComponents size! !

!DirectionlessGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
testConnectionTesting

	self assert: ( (graph vertexNamed: 'B') isConnectedTo: (graph vertexNamed: 'A')).
	self deny: ( (graph vertexNamed: 'B') isConnectedTo: (graph vertexNamed: 'P')).
	self assert: ( (graph vertexNamed: 'F') isConnectedTo: (graph vertexNamed: 'J')).
	self deny: ( (graph vertexNamed: 'F') isConnectedTo: (graph vertexNamed: 'E')).
	self assert: ( (graph vertexNamed: 'M') isConnectedTo: (graph vertexNamed: 'N')).
	self deny: ( (graph vertexNamed: 'M') isConnectedTo: (graph vertexNamed: 'D')).
	self assert: ( (graph vertexNamed: 'C') isConnectedTo: (graph vertexNamed: 'G')).! !

!DirectionlessGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
testEdgeCount

	self assertEquals: 16 to: graph edges size! !

!DirectionlessGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
testIsTree

	self deny: graph isTree! !

!GraphTestCase classSide methodsFor: 'testing' stamp: 'hjo 9/18/2009 20:21'!
isAbstract

	^true! !

!GraphTestCase methodsFor: 'asserting' stamp: 'hjo 9/19/2009 15:42'!
assertEquals: collection1 visitation: collection2

	self assert: (collection1 size = collection2 size and: [ collection1 asSet equalElementsTo: collection2 asSet ])! !

!GraphTestCase methodsFor: 'running' stamp: 'hjo 9/18/2009 20:21'!
setUp

	super setUp.
	graph := Graph new.! !

GraphTestCase subclass: #TreeLikeGraphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!TreeLikeGraphTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:25'!
isAbstract

	^false! !

!TreeLikeGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
setUp

	super setUp.
	'ABCDEFG' do: [:each| graph addVertex: Vertex new named: each asString ].

	#('AB' 'BC' 'BD' 'AE' 'EF' 'EG') do: [:each| graph connect: each first asString and: each second asString ]! !

!TreeLikeGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:24'!
testConnectedComponents

	self assertEquals: 1 to: graph connectedComponents size! !

!TreeLikeGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:25'!
testIsTree

	self assert: graph isTree! !

GraphTestCase subclass: #UnconnectedGraphTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Tests'!

!UnconnectedGraphTestCase classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:26'!
isAbstract

	^false! !

!UnconnectedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:25'!
setUp

	super setUp.
	
	'ABCDEFG' do: [:each| graph addVertex: Vertex new named: (String with: each) ].
	#('AB' 'BC' 'CA' 'DE' 'EG' 'GF' 'FD') 
		do: [:each| graph connect: each first asString and: each second asString ].
! !

!UnconnectedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:26'!
testConnectedComponents

	self assertEquals: #(3 4) asSortedCollection to: (graph connectedComponents collect: [:subGraph| subGraph vertices size ]) asSortedCollection! !

!UnconnectedGraphTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:26'!
testIsTree

	self deny: graph isTree! !

Object subclass: #BreadthFirstGraphVisitor
	instanceVariableNames: 'currentVertices vertexOperation edgeOperation visitedVertices nextVerticesToVisit nextEdgesToVisit edgeAccessingMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Core'!

!BreadthFirstGraphVisitor methodsFor: 'state changing' stamp: 'hjo 9/18/2009 16:04'!
beBackwardGoing

	self edgeAccessingMethod: #edgesThatCanEnter! !

!BreadthFirstGraphVisitor methodsFor: 'state changing' stamp: 'hjo 9/18/2009 16:04'!
beForwardGoing

	self edgeAccessingMethod: #edgesThatCanLeave! !

!BreadthFirstGraphVisitor methodsFor: 'running' stamp: 'hjo 9/20/2009 15:40'!
breadthFirstSearch

	self currentVertices do: 
		[ :vertex| 
			| accessingEdgesToNextVerticesToVist |
			accessingEdgesToNextVerticesToVist := 
				(vertex perform: self edgeAccessingMethod)
					reject: [:edge| self visitedVertices includes: (edge otherEndPointOf: vertex) ].
			accessingEdgesToNextVerticesToVist 
				do: 
				[:each| 
					self nextVerticesToVisit add: (each otherEndPointOf: vertex)
				].
			self nextEdgesToVisit addAll: accessingEdgesToNextVerticesToVist
		]! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:05'!
currentVertices

	^currentVertices! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:05'!
currentVertices: anArray 

	^currentVertices := anArray asSet! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:05'!
edgeAccessingMethod

	edgeAccessingMethod isNil ifTrue: [ edgeAccessingMethod := #edgesThatCanLeave ].
	^edgeAccessingMethod! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:05'!
edgeAccessingMethod: aSymbol

	edgeAccessingMethod := aSymbol! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:05'!
edgeOperation

	edgeOperation isNil ifTrue: [ edgeOperation := DeafObject new ].
	^edgeOperation! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:06'!
edgeOperation: aBlockClosure 

	^edgeOperation := aBlockClosure 
! !

!BreadthFirstGraphVisitor methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:06'!
isBackwardGoing

	self edgeAccessingMethod = #edgesThatCanEnter! !

!BreadthFirstGraphVisitor methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:06'!
isForwardGoing

	self edgeAccessingMethod = #edgesThatCanLeave! !

!BreadthFirstGraphVisitor methodsFor: 'querying' stamp: 'hjo 9/20/2009 15:40'!
nextEdgesToVisit 

	nextEdgesToVisit isNil 
		ifTrue: [ 
			nextEdgesToVisit := Set new.
			self breadthFirstSearch
		].
	^nextEdgesToVisit! !

!BreadthFirstGraphVisitor methodsFor: 'querying' stamp: 'hjo 9/20/2009 15:40'!
nextVerticesToVisit

	nextVerticesToVisit isNil 
		ifTrue: [ 
			nextVerticesToVisit := Set new.
			self breadthFirstSearch
		].
	^nextVerticesToVisit
! !

!BreadthFirstGraphVisitor methodsFor: 'running' stamp: 'hjo 9/18/2009 16:06'!
run

	[ self step. self nextVerticesToVisit isEmpty ] whileFalse! !

!BreadthFirstGraphVisitor methodsFor: 'running' stamp: 'hjo 9/18/2009 16:07'!
step

	"Based on BFS(Breath First Search) algorithm"
	self currentVertices do: [:each| self vertexOperation value: each.  self visitedVertices add: each ].
	nextVerticesToVisit := nil.
	nextEdgesToVisit := nil.
	self nextEdgesToVisit do: [:each| self edgeOperation value: each ].
	self currentVertices: self nextVerticesToVisit! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:07'!
vertexOperation

	vertexOperation isNil ifTrue: [ vertexOperation := DeafObject new ].
	^vertexOperation! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:07'!
vertexOperation: aBlockClosure 

	^vertexOperation := aBlockClosure 
! !

!BreadthFirstGraphVisitor methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:07'!
visitedVertices

	visitedVertices isNil ifTrue: [ visitedVertices := Set new ].
	^visitedVertices! !

Object subclass: #DeafObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-DolphinPort'!

!DeafObject commentStamp: 'hjo 9/18/2009 16:13' prior: 0!
From Dolphin. Squeak is missing it.!

!DeafObject methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 15:44'!
doesNotUnderstand: aSymbol

	"neglect all messages"! !

Object subclass: #Edge
	instanceVariableNames: 'endPoint1 endPoint2 hasDirection masterObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Core'!

!Edge commentStamp: 'hjo 9/18/2009 16:13' prior: 0!
Edge connect two vertices. Edge sand Vertices form a graph mathematically.!

Edge subclass: #CostEdge
	instanceVariableNames: 'cost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!CostEdge methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 16:38'!
cost

	^cost! !

!CostEdge methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 16:38'!
cost: anObject

	cost := anObject! !

!Edge methodsFor: 'comparing' stamp: 'hjo 9/19/2009 15:42'!
= anEdge
	
"Two edges connecting the same two points i,j are regarded same. If the edge has direction, the test becomes more tight."
	self hasDirection
		ifTrue: [ 
			^anEdge hasDirection and:
			[(self endPoint1 = anEdge endPoint1) and:
			[self endPoint2 = anEdge endPoint2]]]
		ifFalse: [^self endPoints equalElementsTo: anEdge endPoints]
! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:14'!
atLeastOneTerminalConnected

	^endPoint1 notNil or: [endPoint2 notNil]! !

!Edge methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:14'!
basicConnect: aVertex and: bVertex

	endPoint1 := aVertex.
	aVertex addEdge: self.

	endPoint2 := bVertex.
	bVertex addEdge: self.

	self onConnect! !

!Edge methodsFor: 'state changing' stamp: 'hjo 9/18/2009 16:14'!
beDirected

	hasDirection := true! !

!Edge methodsFor: 'state changing' stamp: 'hjo 9/18/2009 16:14'!
beUndirected

	hasDirection := false! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:14'!
bothTerminalConnected

	^endPoint1 notNil and: [ endPoint2 notNil ]! !

!Edge methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:14'!
connect: aVertex and: bVertex

	self beUndirected.
	self basicConnect: aVertex and: bVertex! !

!Edge methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:15'!
connectFrom: aVertex to: bVertex
"Connects vertices with direction"
	
	self beDirected.	
	self basicConnect: aVertex and: bVertex! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:15'!
connects: aVertex

	^(endPoint1 == aVertex) or: [endPoint2 == aVertex]! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:15'!
connects: aVertex and: bVertex

	|endPoints|
	endPoints := self endPoints.
	^(endPoints includes: aVertex) and: [endPoints includes: bVertex]
! !

!Edge methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:15'!
disconnect

	self endPoint1 removeEdge: self.
	self endPoint1: nil.
	self endPoint2 removeEdge: self.
	self endPoint2: nil.! !

!Edge methodsFor: 'drawing' stamp: 'hjo 9/18/2009 16:15'!
drawOn: aCanvas

	aCanvas moveTo: endPoint1 position asPoint.
	aCanvas lineTo: endPoint2 position asPoint.! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:15'!
endPoint1

	^endPoint1! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:15'!
endPoint1: aVertex

	^endPoint1 := aVertex! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:16'!
endPoint2

	^endPoint2! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:16'!
endPoint2: aVertex

	^endPoint2 := aVertex! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 15:55'!
endPoints

	| ep |
	ep := Set new.
	endPoint1 ifNotNil: [ ep add: endPoint1 ].
	endPoint2 ifNotNil: [ ep add: endPoint2 ].
	^ep! !

!Edge methodsFor: 'error handling' stamp: 'hjo 9/18/2009 16:16'!
errorUndirectedEdge

	self error: 'Undirected Edge cannot do that'! !

!Edge methodsFor: 'error handling' stamp: 'hjo 9/18/2009 16:16'!
errorVertexMissing

	self error: 'The vertex is not an end point of this edge'! !

!Edge methodsFor: 'printing' stamp: 'hjo 9/18/2009 16:16'!
extraPrintString

	^String empty! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:16'!
hasDirection

	^self isDirectedEdge! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:17'!
initialPoint

	self hasDirection ifFalse: [ self errorUndirectedEdge ].
	^endPoint1
! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:17'!
initialPoint: aVertex

	self hasDirection ifFalse: [ self errorUndirectedEdge ].
	^endPoint1 := aVertex
! !

!Edge methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 16:17'!
initialize

	super initialize.
	hasDirection := false! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:17'!
isDirectedEdge

	^hasDirection = true
! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:17'!
isLoop

	^endPoint1 == endPoint2! !

!Edge methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:17'!
isMultipleEdgeWith: anEdge

	^self endPoints = anEdge endPoints! !

!Edge methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:17'!
letGo: aVertex

"Remove reference to aVertex. End points must be determined ahead."
	(self endPoint1 == aVertex)
		ifTrue: [ ^self endPoint1: nil ].
	(self endPoint2 == aVertex)
		ifTrue: [ ^self endPoint2: nil ].
	self errorVertexMissing! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 18:51'!
masterObject

	^masterObject! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 18:51'!
masterObject: anObject

	masterObject := anObject! !

!Edge methodsFor: 'event handling' stamp: 'hjo 9/18/2009 16:18'!
onConnect

	"After connection established"! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:18'!
otherEndPointOf: aVertex

	(self endPoint1 == aVertex)
		ifTrue: [ ^self endPoint2 ].
	(self endPoint2 == aVertex)
		ifTrue: [ ^self endPoint1 ].
	self errorVertexMissing	! !

!Edge methodsFor: 'printing' stamp: 'hjo 9/18/2009 16:18'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: endPoint1 name;
		nextPut: $,;
		nextPutAll: endPoint2 name;
		nextPutAll: self extraPrintString;
		nextPut: $)! !

!Edge methodsFor: 'drawing' stamp: 'hjo 9/18/2009 16:18'!
rectangleToInvalidate

	^(endPoint1 position asPoint corner: endPoint2 position asPoint) normalize! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:18'!
terminalPoint

	self hasDirection ifFalse: [ self errorUndirectedEdge ].
	^endPoint2! !

!Edge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:18'!
terminalPoint: aVertex

	self hasDirection ifFalse: [ self errorUndirectedEdge ].
	^endPoint2 := aVertex! !

Edge subclass: #FlowEdge
	instanceVariableNames: 'capacity flow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:43'!
capacity

	^capacity! !

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:44'!
capacity: aNumber

	^capacity := aNumber! !

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:46'!
flow

	^flow! !

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:46'!
flow: aFlowNumber
	
	capacity notNil
		ifTrue: [^flow := aFlowNumber min: capacity]
		ifFalse: [^flow := aFlowNumber]! !

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:47'!
flowEntering: aVertex

	(aVertex == self endPoint1)
		ifTrue: [ ^self flow negated ].
	(aVertex == self endPoint2)
		ifTrue: [ ^self flow ].
	self errorVertexMissing
! !

!FlowEdge methodsFor: 'testing' stamp: 'hjo 9/19/2009 16:48'!
hasFlowLimit

	^self flow notNil! !

!FlowEdge methodsFor: 'testing' stamp: 'hjo 9/19/2009 16:48'!
isFlowOffLimit

	^(self hasDirection)
		ifTrue: [ flow > capacity ]
		ifFalse: [ flow abs > capacity abs ]! !

!FlowEdge methodsFor: 'accessing' stamp: 'hjo 9/19/2009 16:49'!
noFlowLimit

	self flow: nil! !

Edge subclass: #GraphDistance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!GraphDistance commentStamp: '<historical>' prior: 0!
Stores distance between its two end point in the instance variable named "cost".
Distance is symentically undirected edge.!

!GraphDistance methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:30'!
onConnect

	self updateCost! !

!GraphDistance methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:30'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: cost printString;
		nextPut: $)! !

!GraphDistance methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:31'!
updateCost

	cost := (endPoint1 position - endPoint2 position) normalized! !

Edge subclass: #PlotEdge
	instanceVariableNames: 'type color thickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Graphics'!

!PlotEdge methodsFor: 'state changing' stamp: 'hjo 9/18/2009 19:31'!
beDashed

	type := #dashed! !

!PlotEdge methodsFor: 'state changing' stamp: 'hjo 9/18/2009 19:32'!
beSolid

	type := #solid! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:32'!
color
	"Private - Answer the value of the receiver's ''color'' instance variable."

	^color! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:32'!
color: anObject
	"Private - Set the value of the receiver's ''color'' instance variable to the argument, anObject."

	color := anObject! !

!PlotEdge methodsFor: 'graphics' stamp: 'hjo 9/18/2009 19:32'!
drawOn: aCanvas

"	Dolphin4 Code
	|oPen|
	oPen := aCanvas pen: (Pen withStyle: self penStyle width: thickness color: color).
	super drawOn: aCanvas.
	aCanvas pen: oPen"! !

!PlotEdge methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 19:33'!
initialize

	super initialize.
	type := #solid.
	color := Color red.
	thickness := 2.! !

!PlotEdge methodsFor: 'graphics' stamp: 'hjo 9/18/2009 19:33'!
penStyle

"	Dolphin4 code
	(type = #dashed) ifTrue: [^PS_DASH].
	(type = #solid) ifTrue: [^PS_SOLID].
	^PS_DASH"! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:33'!
thickness

	^thickness! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:33'!
thickness: anInteger

	thickness := anInteger! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:33'!
type

	^type! !

!PlotEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:33'!
type: aSymbol

	type := aSymbol! !

Edge subclass: #StateEdge
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-StateMachine'!

!StateEdge methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:35'!
output

	^output! !

!StateEdge methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:35'!
output: anObject

	output := anObject! !

StateEdge subclass: #StochasticEdge
	instanceVariableNames: 'probability'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Stochastic'!

!StochasticEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:35'!
probability

	^probability! !

!StochasticEdge methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:35'!
probability: aNumber

	probability := aNumber! !

Object subclass: #Graph
	instanceVariableNames: 'vertices nameTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Core'!

!Graph commentStamp: 'hjo 9/19/2009 18:02' prior: 0!
'We meet graphs in different fields under different names: as "networks" in electrical engineering, "structures" in civil engineergin, "molecular structres" in chemistry, "organizational structures" in economics, "sociograms," "road maps," "telecommunications networks," and so on.

See Also: Vertex, Edge, Path'

Edges are not stored in me. Edges are indirectly stored via vertices.!

Graph subclass: #CostGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!CostGraph classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 17:52'!
costedExample

"A weighted undirected graph"
	| a b c d e f g h i j k l m graph|
	graph := self new.
	graph
		addVertex: (a := Vertex new);
		addVertex: (b := Vertex new);
		addVertex: (c := Vertex new);
		addVertex: (d := Vertex new);
		addVertex: (e := Vertex new);
		addVertex: (f := Vertex new);
		addVertex: (g := Vertex new);
		addVertex: (h := Vertex new);
		addVertex: (i := Vertex new);
		addVertex: (j := Vertex new);
		addVertex: (k := Vertex new);
		addVertex: (l := Vertex new);
		addVertex: (m := Vertex new).

	a connect: b cost: 1.
	a connect: f cost: 2.
	a connect: g cost: 6.
	b connect: d cost: 2.
	b connect: c cost: 1.
	b connect: e cost: 4.
	d connect: f cost: 1.
	d connect: e cost: 2.
	c connect: e cost: 4.
	f connect: e cost: 2.
	f connect: l cost: 2.
	g connect: e cost: 1.
	g connect: h cost: 3.
	g connect: j cost: 1.
	g connect: l cost: 5.
	h connect: i cost: 2.
	j connect: k cost: 1.
	j connect: l cost: 3.
	i connect: k cost: 1.
	j connect: m cost: 2.
	l connect: m cost: 1.
	^graph	
! !

!CostGraph methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 17:19'!
shortestPathsFrom: beginVertex
"Dijkstra's Algorithm"
	| shortestPaths graphOfVisitedVertices unvisited nearVertices gateVertices temporalShortestPaths  john small margaret shortestPathToGateVertex |
	unvisited := self vertices copy.
	graphOfVisitedVertices := self class new.
	shortestPaths := Dictionary new.
	
	unvisited give: beginVertex to: graphOfVisitedVertices vertices.
	shortestPaths
		at: beginVertex
		put: (GraphPath from: beginVertex to: beginVertex through: OrderedCollection new).

	nearVertices := graphOfVisitedVertices neighboringVertices.
	nearVertices do: 
		[:nearVertex| 
			temporalShortestPaths := Dictionary new.
			gateVertices := nearVertex neighbors intersection: graphOfVisitedVertices vertices.
			gateVertices do: [:gateVertex|
				shortestPathToGateVertex := shortestPaths at: gateVertex.
				self halt.
				margaret := gateVertex edgesConnecting: nearVertex.
				john := margaret function: [:edge| edge cost ].
				small := john keyAtValue: john asSortedCollection last.
				temporalShortestPaths
					at: gateVertex
					put: (shortestPathToGateVertex copy addEdgeLast: small) ]].! !

!Graph classSide methodsFor: 'instance creation' stamp: 'hjo 9/18/2009 16:57'!
createWithFullyConnectedVertices: aCollection

	|unconnected graph|
	graph := self vertices: aCollection asSet.
	unconnected := aCollection asSet.
	graph vertices do: [:vertex| |toConnect|
		toConnect := unconnected - vertex neighbors.
		toConnect remove: vertex.
		vertex connectAll: toConnect ].
	^graph! !

!Graph classSide methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:57'!
defaultVertexClass

	^Vertex! !

!Graph classSide methodsFor: 'examples' stamp: 'hjo 9/18/2009 16:57'!
example

	| graph |
	graph := self new.
	graph addVerticesNamed: #(a b c d e f g h i j k l m).
	(graph vertexNamed: #a) 
		connectAll: (graph verticesNamed: #(b c g f)).
	(graph vertexNamed: #f)
		connectAll: (graph verticesNamed: #(d e)).
	(graph vertexNamed: #h)
		connectAll: (graph verticesNamed: #(i g)).
	(graph vertexNamed: #j)
		connectAll: (graph verticesNamed: #(k m l g)).
	(graph vertexNamed: #l)
		connectAll: (graph verticesNamed: #(m g)).
	(graph vertexNamed: #e)
		connectAll: (graph verticesNamed: #(d g)).
	(graph vertexNamed: #c)
		connect: (graph vertexNamed: #g).
	^graph! !

!Graph classSide methodsFor: 'instance creation' stamp: 'hjo 9/18/2009 16:58'!
vertices: aVertexCollection

	^self new
		vertices: aVertexCollection;
		yourself! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:21'!
addAllVertices: aCollection

	^self vertices addAll: aCollection! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:21'!
addVertex: aVertex

	^self vertices add: aVertex! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:21'!
addVertex: aVertex named: aString

	[^self vertices add: aVertex] ensure: [self name: aVertex as: aString]! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:22'!
addVertexNamed: aString

	self
		addVertex: (self class defaultVertexClass new name: aString asString)
		named: aString
	"[^self vertices add: aVertex] ensure: [self name: aVertex as: aString]"! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:22'!
addVerticesNamed: aCollection

	aCollection do: [:vertexName| self addVertexNamed: vertexName ]! !

!Graph methodsFor: 'data structures' stamp: 'hjo 9/18/2009 16:22'!
adjacencyMatrix
"By definition, no vertex is considered to be adjacents to itself. The adjacencyMatrix is always symmetric. The adjacency matrix of a graph is generally much smaller than thesocalled incidence matrix"
	self notImplemented! !

!Graph methodsFor: 'data structures' stamp: 'hjo 9/18/2009 16:30'!
aminimumSpanningTree

"Kruscal's Algorithm"
	self notYetImplemented! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:22'!
backBreadthFirstDo: aVertexProcessingBlock startingAt: aVertex
"Based on BFS(Breath First Search) algorithm"

	self
		backBreadthFirstDo: aVertexProcessingBlock
		startingAt: aVertex
		visitedVertices: (Set new: self vertices size) ! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:22'!
backBreadthFirstDo: aVertexProcessingBlock startingAt: aVertex visitedVertices: visited
"Based on BFS(Breath First Search) algorithm"

	self
		backBreadthFirstDo: aVertexProcessingBlock
		startingVertices: (Set with: aVertex)
		visitedVertices: visited! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:23'!
backBreadthFirstDo: aVertexProcessingBlock startingVertices: aSet1 visitedVertices: aSet2
"Based on BFS(Breath First Search) algorithm"

	self backBreadthFirstDoVertex: aVertexProcessingBlock doEdge: [:edge|] startingVertices: aSet1 visitedVertices: aSet2! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:23'!
backBreadthFirstDoVertex: aVertexProcessingBlock doEdge: anEdgeProcessingBlock startingVertices: aSet1 visitedVertices: aSet2
"Based on BFS(Breath First Search) algorithm"
	| aboutToVisit visited|
	visited := aSet2 copy.
	aboutToVisit := aSet1 copy.

	[ aboutToVisit do: [:vertex| aVertexProcessingBlock value: vertex].
	   visited addAll: aboutToVisit.
	   aboutToVisit do: [:vertex| vertex edgesThatCanEnter do: [:leavingEdge| anEdgeProcessingBlock value: leavingEdge].
						aboutToVisit addAll: vertex backNeighbors ].
	   aboutToVisit := 
		aboutToVisit select:
			[:vertex| (self vertices includes: vertex) and:
				[(visited includes: vertex) not]].
	aboutToVisit isEmpty ] whileFalse! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:23'!
backNeighboringVertices
"a set of vertices that is connected to the vertex of this graph but not included in this graph"

	^(self vertices dump: [:vertex| vertex backNeighbors ])
		reject: [:vertex| self vertices includes: vertex]! !

!Graph methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:23'!
connect: vertexName1 and: vertexName2

	"Simplified version of connecting vertices by using its names."
	^(self vertexNamed: vertexName1) connect: (self vertexNamed: vertexName2).! !

!Graph methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:23'!
connect: vertexName1 to: vertexName2

	^(self vertexNamed: vertexName1) connectTo: (self vertexNamed: vertexName2)! !

!Graph methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:24'!
connectVertices: collection1 andVertices: collection2

	collection1 do: [:eachNode | eachNode connectAll: collection2 ].! !

!Graph methodsFor: 'connecting' stamp: 'hjo 9/18/2009 16:24'!
connectVertices: collection1 toVertices: collection2

	collection1 do: [:eachNode | eachNode connectToAll: collection2 ].! !

!Graph methodsFor: 'querying' stamp: 'hjo 9/20/2009 15:39'!
connectedComponents

	| components unvisitedVertices |
	unvisitedVertices := self vertices copy.
	components := Set new.
	[	| visitor |
		(visitor := BreadthFirstGraphVisitor new)
			currentVertices: (Array with: unvisitedVertices anyOne);
			run.
		components add: (self class vertices: visitor visitedVertices).
		unvisitedVertices removeAll: visitor visitedVertices.

		unvisitedVertices isEmpty
	] whileFalse.
	^components! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/18/2009 16:25'!
depthFirstDo: aVertexProcessingBlock startingAt: aVertex

	"Based on Nonrecursive DFS(Depth First Search) algorithm"
	| visited currentVertex vertexStack aboutToVisit |
	currentVertex := aVertex.
	visited := Set new: self vertices size.
	vertexStack := Stack new.
	vertexStack push: currentVertex.

	[ aboutToVisit := currentVertex neighbors reject:
		[:vertex| (self vertices excludes: vertex) or:
			[(visited includes: vertex) or: [vertexStack includes: vertex]] ].
	aboutToVisit isEmpty
		ifTrue: [ aVertexProcessingBlock value: currentVertex.
			visited add: currentVertex.
			currentVertex := vertexStack pop]
		ifFalse: [ vertexStack pushAll: aboutToVisit ].
	 vertexStack isEmpty ] whileFalse! !

!Graph methodsFor: 'querying' stamp: 'hjo 9/18/2009 16:25'!
directionedEdges

	^self edges select: [:each| each isDirectedEdge ]! !

!Graph methodsFor: 'querying' stamp: 'hjo 9/18/2009 16:26'!
directionlessEdge

	^self edges reject: [:each| each isDirectedEdge ]! !

!Graph methodsFor: 'drawing' stamp: 'hjo 9/18/2009 16:26'!
drawOn: aCanvas

	self edges do: [:edge| edge drawOn: aCanvas].
		self vertices do: [:vertex|	vertex drawOn: aCanvas]
! !

!Graph methodsFor: 'drawing' stamp: 'hjo 9/18/2009 16:27'!
drawOn: aCanvas withMapper: aMapper

	self edges do: [:edge| edge drawOn: aCanvas withMapper: aMapper].
		self vertices do: [:positionedVertex|
			positionedVertex drawOn: aCanvas withMapper: aMapper]
! !

!Graph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:27'!
edges

	| edges |
	edges := Set new.
	self vertices do: [:v| edges addAll: v edges].
	^edges! !

!Graph methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 16:27'!
finalizeAllVertices

	self vertices do: [:vertex| vertex finalize ]! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:28'!
hasVertexNamed: aKey

	^nameTable includesKey: aKey! !

!Graph methodsFor: 'data structures' stamp: 'hjo 9/18/2009 16:28'!
incidenceMatrix

	self notImplemented! !

!Graph methodsFor: 'initialize-release' stamp: 'hjo 9/19/2009 15:38'!
initialize

	self removeAllVertices.
	nameTable := WeakValueDictionary new.! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:29'!
isComplete

"This is not enough for testing completeness of a graph."
	| verticesSize |
	verticesSize := self vertices size.
	^self edges size >= verticesSize * (verticesSize - 1) / 2 and: [ self connectedComponents size ]! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/20/2009 15:39'!
isConnected
"A graph is connected if there is a path from every vertex to every other vertex in the graph"
	| visitor |
	visitor := BreadthFirstGraphVisitor new.
	visitor currentVertices: (Array with: self vertices anyOne).
	visitor run.
	^visitor visitedVertices equalElementsTo: self vertices
	"| connectedVertices |
	connectedVertices := Set new.
	self
		breadthFirstDo: [:vertex| connectedVertices add: vertex ]
		startingAt: self vertices any.
	^self vertices equals: connectedVertices"! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:30'!
isDense

	^self isSparse not! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:30'!
isDigraph
"DiGraph is a Graph whose edges are all directed edge.
Two edges connecting the same two points i,j are now permitted, provided they have opposite directions, they are (i,j) and (j,i)"
	^self edges allSatisfy: [:e| e isDirectedEdge ]! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:30'!
isSparse

	| verticesSize |
	verticesSize := self vertices size.
	^self edges size < (verticesSize * verticesSize log)! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/18/2009 16:30'!
isSubgraphOf: aGraph

"A subgraph or subdigraph of a given graph or digraph G = (V, E), resepectively, is a graph or digraph obtained by deleting some of the edges and vertices of G, retaining the other edges of G(together with their pairs of endpoints)."
	^(self vertices isSubcollectionOf: aGraph vertices)
		and: [ self edges isSubcollectionOf: aGraph edges]! !

!Graph methodsFor: 'testing' stamp: 'hjo 9/20/2009 15:40'!
isTree
"A graph with no cycles is called a tree"

	| visitedEdges |
	visitedEdges := Set new.
	BreadthFirstGraphVisitor new
		currentVertices: (Array with: self vertices anyOne);
		edgeOperation: [:edge| visitedEdges add: edge ];
		run.
	^visitedEdges equalElementsTo: self edges
	
	"|visited|
	visited := Set new.
	self
		breadthFirstDo:
			[:vertex|(self vertices includes: vertex)
				ifTrue: [^false]
				ifFalse: [visited add: vertex]]
		startingAt: self vertices asArray first.
	^true"! !

!Graph methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 16:30'!
letGoVertex: aVertex

	aVertex finalize! !

!Graph methodsFor: 'names' stamp: 'hjo 9/18/2009 16:31'!
name: aVertex as: aString

	^nameTable at: aString put: aVertex! !

!Graph methodsFor: 'finding' stamp: 'hjo 9/18/2009 16:31'!
nameOf: aVertex

	^nameTable keyAtValue: aVertex! !

!Graph methodsFor: 'querying' stamp: 'hjo 9/18/2009 16:31'!
neighboringVertices
"a set of vertices that is connected to the vertex of this graph but not included in this graph"

	^(self vertices dump: [:vertex| vertex neighbors ])
		reject: [:vertex| self vertices includes: vertex]! !

!Graph methodsFor: 'names' stamp: 'hjo 9/18/2009 16:31'!
nodeNames
	
	^nameTable keys! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:31'!
removeAllVertices

	vertices := Set new.! !

!Graph methodsFor: 'vertex' stamp: 'hjo 9/18/2009 16:31'!
removeVertex: aVertex

	self vertices remove: aVertex ifAbsent: [self error: 'Can''t remove unexisting node'].! !

!Graph methodsFor: 'visiting operation' stamp: 'hjo 9/19/2009 17:57'!
shortestPathFrom: beginVertex to: goalVertex
"Dijkstra's Algorithm"
	| path visited unvisited |
	self revisit: 'I don''t get it. What is this for?'.
	path := WriteStream on: (Array with: beginVertex).
	unvisited := self vertices.
	visited := Set new: unvisited size.
	[
	unvisited isEmpty ] whileFalse! !

!Graph methodsFor: 'finding' stamp: 'hjo 9/19/2009 17:48'!
vertexNamed: aString

	^nameTable at: aString ifAbsent:  [ self vertices detect: [:vertex| vertex name = aString ]]! !

!Graph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:56'!
vertices

	^vertices! !

!Graph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 16:56'!
vertices: aCollection

	vertices := aCollection asSet! !

!Graph methodsFor: 'finding' stamp: 'hjo 9/18/2009 16:56'!
verticesNamed: aCollection

	^aCollection collect: [:vertexName| self vertexNamed: vertexName]! !

Graph subclass: #PlotGraph
	instanceVariableNames: 'edgeColor edgeStyle edgeThickness vertexColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Graphics'!

!PlotGraph classSide methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:38'!
defaultVertexClass

	^PlotVertex! !

!PlotGraph classSide methodsFor: 'examples' stamp: 'hjo 9/18/2009 19:38'!
example

	|g|
	g := super example.
	g vertices do: [:vv| vv position: 20@30].
	^g! !

!PlotGraph methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 19:36'!
createOneThreadOfEdgesConnectingAllVertices: aSequenceableCollection

	|previousVertex vertexStream|
	vertexStream := aSequenceableCollection readStream.
	previousVertex := vertexStream next.
	[vertexStream atEnd] whileFalse:[ |nextVertex|
		nextVertex := vertexStream next.
		previousVertex connect: nextVertex.
		previousVertex := nextVertex].
	self addAllVertices: aSequenceableCollection! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:36'!
edgeColor

	^edgeColor! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:37'!
edgeColor: aColor

	edgeColor := aColor! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:36'!
edgeStyle

	^edgeStyle! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:36'!
edgeStyle: aSymbol

	edgeStyle := aSymbol! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:36'!
edgeThickness

	^edgeThickness! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:36'!
edgeThickness: anInteger

	edgeThickness := anInteger! !

!PlotGraph methodsFor: 'operation' stamp: 'hjo 9/18/2009 19:37'!
prepareDrawing

	self edges do: [:edge| edge color: edgeColor; thickness: edgeThickness; type: edgeStyle].
	self vertices do: [:vertex|vertex color:  vertexColor]! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:38'!
vertexColor

	^vertexColor! !

!PlotGraph methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:38'!
vertexColor: aColor

	vertexColor := aColor
! !

Object subclass: #GraphPath
	instanceVariableNames: 'edgeSequence startVertex endVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!GraphPath commentStamp: 'hjo 9/18/2009 15:10' prior: 0!
Original name on Dolphin 4 was 'Path'.  It collided so I renamed.!

!GraphPath classSide methodsFor: 'examples' stamp: 'hjo 9/18/2009 17:16'!
example

	| e1 e2 e3 v1 v2 v3 v4 p | 
	e1 := Edge new.
	e2 := Edge new.
	e3 := Edge new.

	v1 := Vertex new.
	v2 := Vertex new.
	v3 := Vertex new.
	v4 := Vertex new.

	v1 name: 'v1'.
	v2 name: 'v2'.
	v3 name: 'v3'.
	v4 name: 'v4'.

	e1 connect: v1 and: v2.
	e2 connect: v2 and: v3.
	e3 connect: v3 and: v4.

	p := Path new.
	p startVertex: v1.
	p endVertex: v4.
	p edgeSequence: (OrderedCollection with: e1 with: e2 with: e3).
	^p! !

!GraphPath classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 17:16'!
from: aVertex to: bVertex through: anEdgeSequence

	^self new
		startVertex: aVertex;
		endVertex: bVertex;
		edgeSequence: anEdgeSequence;
		yourself! !

!GraphPath methodsFor: 'adding' stamp: 'hjo 9/18/2009 17:13'!
addEdgeFirst: anEdge

	self
		edgeSequence: (Array with: anEdge),self edgeSequence;
		endVertex: (anEdge otherEndPointOf: self endVertex);
		yourself! !

!GraphPath methodsFor: 'adding' stamp: 'hjo 9/18/2009 17:13'!
addEdgeLast: anEdge

	self
		edgeSequence: self edgeSequence , (Array with: anEdge);
		endVertex: (anEdge otherEndPointOf: self endVertex);
		yourself
! !

!GraphPath methodsFor: 'adding' stamp: 'hjo 9/18/2009 17:13'!
addVertexFirst: aVertex

	|edge|
	edge := aVertex edgeConnecting: startVertex.
	edgeSequence addFirst: edge.
	startVertex := aVertex.! !

!GraphPath methodsFor: 'adding' stamp: 'hjo 9/18/2009 17:13'!
addVertexLast: aVertex

	|edge|
	edge := endVertex edgeConnecting: aVertex.
	edgeSequence addLast: edge.
	endVertex := aVertex.! !

!GraphPath methodsFor: 'state changing' stamp: 'hjo 9/18/2009 17:14'!
beOfOneEdge: anEdge

	startVertex := anEdge endPoint1.
	endVertex := anEdge endPoint2.
	edgeSequence := OrderedCollection with: anEdge! !

!GraphPath methodsFor: 'computing' stamp: 'hjo 9/18/2009 17:14'!
cost

	^self edgeSequence inject: 0 into: [:costSum :edge| edge cost + costSum ]! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:14'!
edgeSequence
	"Private - Answer the value of the receiver's ''edgeSequence'' instance variable."

	^edgeSequence! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:14'!
edgeSequence: anObject
	"Private - Set the value of the receiver's ''edgeSequence'' instance variable to the argument, anObject."

	edgeSequence := anObject! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:14'!
endVertex
	"Private - Answer the value of the receiver's ''endVertex'' instance variable."

	^endVertex! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:15'!
endVertex: anObject
	"Private - Set the value of the receiver's ''endVertex'' instance variable to the argument, anObject."

	endVertex := anObject! !

!GraphPath methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 17:15'!
initialize

	super initialize.
	startVertex := endVertex := nil.
	edgeSequence := OrderedCollection new! !

!GraphPath methodsFor: 'testing' stamp: 'hjo 9/18/2009 17:15'!
isCycle

	^(self startVertex = self endVertex) and:
		[ self isSimple ]
! !

!GraphPath methodsFor: 'testing' stamp: 'hjo 9/18/2009 17:15'!
isSimple

	^self vertexSequence isRedundant not! !

!GraphPath methodsFor: 'testing' stamp: 'hjo 9/18/2009 17:15'!
isValid
"Each endPoints of edges should share vertex"
	| currentVertex |

	self startVertex isNil ifTrue: [^false].
	self endVertex isNil ifTrue: [^false].
	self edgeSequence isNil ifTrue: [^false].
	currentVertex := self startVertex.
	self edgeSequence do:
		[:edge| (edge connects: currentVertex) ifFalse: [^false].
		currentVertex := edge otherEndPointOf: currentVertex].
	(self endVertex == currentVertex) ifFalse: [^false].
	^true! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:15'!
startVertex
	"Private - Answer the value of the receiver's ''startVertex'' instance variable."

	^startVertex! !

!GraphPath methodsFor: 'accessing' stamp: 'hjo 9/18/2009 17:15'!
startVertex: anObject
	"Private - Set the value of the receiver's ''startVertex'' instance variable to the argument, anObject."

	startVertex := anObject! !

!GraphPath methodsFor: 'computing' stamp: 'hjo 9/18/2009 17:15'!
vertexSequence

	| currentVertex vertexStream |
	
	vertexStream := WriteStream on: Array new.
	currentVertex := self startVertex.
	self edgeSequence do:
		[:edge| vertexStream nextPut: currentVertex.
		currentVertex := edge otherEndPointOf: currentVertex].
	vertexStream nextPut: currentVertex.
	^vertexStream contents
! !

Object subclass: #StateMachine
	instanceVariableNames: 'currentState nameTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-StateMachine'!

!StateMachine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
defaultVertexClass

	^State! !

!StateMachine classSide methodsFor: 'examples' stamp: 'hjo 9/18/2009 19:40'!
example

	"Example from the book 'Evolutionary Computation' page 61 by David B. Fogel"
	| stateMachine stateA stateB stateC |

	"Create StateMachine and States"
	stateMachine := self new.
	stateMachine addVertex: (stateA := self defaultVertexClass new name: 'A').
	stateMachine addVertex: (stateB := self defaultVertexClass new name: 'B').
	stateMachine addVertex: (stateC := self defaultVertexClass new name: 'C').
	
	"Specify relationships between states"
	stateA
		for: 0 give: #beta be: stateB;
		for: 1 give: #beta be: stateA.
	stateB
		for: 0 give: #gamma be: stateB;
		for: 1 give: #alpha be: stateC.
	stateC
		for: 0 give: #beta be: stateB;
		for: 1 give: #gamma be: stateA.
	
	stateMachine state: stateA.
	^stateMachine! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:39'!
input: anObject

	| output |
	output := self state outputFor: anObject.
	self state: (self state nextStateFor: anObject).
	^output! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
inputs: aSeqCollection

	| inStream outStream |

	inStream := aSeqCollection readStream.
	outStream := Array writeStream.
	
	[ inStream atEnd ]
		whileFalse:
		[ outStream nextPut: (self input: (inStream next)) ].
	^outStream contents! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
state

	^currentState! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
state: aState

	currentState := aState! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
stateName

	^nameTable keyAtValue: self state! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
stateNamed: aString

	self state: (self vertexNamed: aString)! !

!StateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:40'!
states

	^self vertices! !

Object subclass: #StochasticStateMachine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Stochastic'!

!StochasticStateMachine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:47'!
defaultVertexClass

	^ProbableState! !

!StochasticStateMachine classSide methodsFor: 'examples' stamp: 'hjo 9/18/2009 19:48'!
example

	|ssm|
	ssm := self new.
	ssm
		addVertex: (self defaultVertexClass new name: 'hungry')  named: 'hungry';
		addVertex: (self defaultVertexClass new name: 'hunt') named: 'hunt';
		addVertex: (self defaultVertexClass new name: 'normal') named: 'normal';
		addVertex: (self defaultVertexClass new name: 'starved') named: 'starved';
		addVertex: (self defaultVertexClass new name: 'tired') named: 'tired'.

	(ssm vertexNamed: 'hungry')
		for: 0.6 give: 'I need food.' be: (ssm vertexNamed: 'hungry');
		for: 0.1 give: 'I''m starving.' be: (ssm vertexNamed: 'starved');
		for: 0.2 give: 'I found a prey!!!!' be: (ssm vertexNamed: 'hunt');
		for: 0.1 give: 'I have no energy do anything.' be: (ssm vertexNamed: 'tired').

	(ssm vertexNamed: 'starved')
		for: 1.0 give: 'rest in peace' be: (ssm vertexNamed: 'starved').

	(ssm vertexNamed: 'hunt')
		for: 0.5 give: 'I''m chasing the prey.' be: (ssm vertexNamed: 'hunt');
		for: 0.2 give: 'I lost it' be: (ssm vertexNamed: 'tired');
		for: 0.3 give: 'I got it!!!! Good Taste!!!!' be: (ssm vertexNamed: 'normal').

	(ssm vertexNamed: 'tired')
		for: 0.4 give: 'I''m so tired.' be: (ssm vertexNamed: 'tired');
		for: 0.3 give: 'I need food to stand up.' be: (ssm vertexNamed: 'hungry');
		for: 0.3 give: 'Not gonna miss this time.' be: (ssm vertexNamed: 'hunt').
		
	(ssm vertexNamed: 'normal')
		for: 0.8 give: 'I''m a happy one.' be: (ssm vertexNamed: 'normal');
		for: 0.1 give: 'I hunt for fun' be: (ssm vertexNamed: 'hunt');
		for: 0.1 give: 'I feel hungry' be: (ssm vertexNamed: 'hungry').

	ssm state: (ssm vertexNamed: 'normal').
	^ssm! !

!StochasticStateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:47'!
globalRanom

	^Collection randomForPicking next! !

!StochasticStateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:47'!
nextState

	^self input: self globalRandom! !

!StochasticStateMachine methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:47'!
nextState: anInteger

	^self inputs: (self globalRandom next: anInteger)
! !

Object subclass: #Vertex
	instanceVariableNames: 'enteringEdges leavingEdges twoWayEdges masterObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Core'!

!Vertex commentStamp: '<historical>' prior: 0!
Vertex is a material to form a Graph. Vertex can be connect by Edge and it knows all Edges that connects to it.!

Vertex subclass: #CostVertex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Extended'!

!CostVertex methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 17:51'!
connect: aVertex cost: aNumber

	^(self connect: aVertex)
		cost: aNumber;
		yourself! !

Vertex subclass: #DrawableVertex
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Graphics'!

!DrawableVertex methodsFor: 'printing' stamp: 'hjo 9/19/2009 17:40'!
detailPrintString

	|string|
	string := super detailPrintString.
	position notNil ifTrue: [ string size = 0 ifFalse: [string := string, ' '].
						string := string, position printString].
	^string! !

!DrawableVertex methodsFor: 'drawing' stamp: 'hjo 9/19/2009 17:38'!
drawOn: aCanvas

	|icon|
	icon := Presenter icon.
	icon drawOn: aCanvas at: position asPoint-((icon extent/2) floor)! !

!DrawableVertex methodsFor: 'accessing' stamp: 'hjo 9/19/2009 17:38'!
position

	^position! !

!DrawableVertex methodsFor: 'accessing' stamp: 'hjo 9/19/2009 17:38'!
position: aVector

	position := aVector! !

!DrawableVertex methodsFor: 'drawing' stamp: 'hjo 9/19/2009 17:38'!
rectangleToInvalidate

	|theRectangle|
	theRectangle := self icon rectangle center: position.
	self edges do: [:edge|theRectangle := theRectangle union: edge rectangleToInvalidate].
	^theRectangle! !

Vertex subclass: #PlotVertex
	instanceVariableNames: 'shape color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Graphics'!

!PlotVertex classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:50'!
designatedEdgeClass

	^PlotEdge! !

!PlotVertex methodsFor: 'state changing' stamp: 'hjo 9/18/2009 20:35'!
beCircle

	shape := #circle! !

!PlotVertex methodsFor: 'state changing' stamp: 'hjo 9/18/2009 20:35'!
beNoShape

	shape = #none
! !

!PlotVertex methodsFor: 'state changing' stamp: 'hjo 9/18/2009 20:35'!
beSquare

	shape := #square! !

!PlotVertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 20:35'!
color

	^color! !

!PlotVertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 20:35'!
color: aColor

	color := aColor! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:36'!
drawCircleOn: aCanvas

"	Dolphin 4 code
	|aBrush|
	aBrush := aCanvas brush: (Brush color: color).
	aCanvas ellipse: self iconRectangle.
	aCanvas brush: aBrush."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:36'!
drawCircleOn: aCanvas withMapper: aMapper

	"Dolphin 4 code
	|aBrush|
	aBrush := aCanvas brush: (Brush color: color).
	aCanvas ellipse: (self iconRectangle magnifiedBy: aMapper ratio).
	aCanvas brush: aBrush."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:36'!
drawOn: aCanvas

	"Dolphin 4 code
	|topLeft|
	topLeft := position asPoint-((self iconSize/2) floor).
	shape = #none ifTrue: [^self].
	shape = #square ifTrue: [^self drawSquareOn: aCanvas].
	shape = #circle ifTrue: [^self drawCircleOn: aCanvas]."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:36'!
drawOn: aCanvas withMapper: aMapper

"	Dolphin 4 code
	|topLeft|
	topLeft := position asPoint-((self iconSize/2) floor).
	shape = #none ifTrue: [^self].
	shape = #square ifTrue: [^self drawSquareOn: aCanvas withMapper: aMapper].
	shape = #circle ifTrue: [^self drawCircleOn: aCanvas withMapper: aMapper]."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:37'!
drawSquareOn: aCanvas

"	Dolphin4 code
	|aBrush|
	aBrush := aCanvas brush: (Brush color: color).
	aCanvas rectangle: self iconRectangle.
	aCanvas brush: aBrush."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:37'!
drawSquareOn: aCanvas withMapper: aMapper

"	Dolphin 4 code
	|aBrush|
	aBrush := aCanvas brush: (Brush color: color).
	aCanvas rectangle: (self iconRectangle magnifiedBy: aMapper ratio).
	aCanvas brush: aBrush."! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:37'!
iconRectangle

	^(0@0 corner: 10@10) center: self position.! !

!PlotVertex methodsFor: 'drawing' stamp: 'hjo 9/18/2009 20:37'!
iconSize

	^10@10! !

!PlotVertex methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 20:37'!
initialize

	super initialize.
	shape := #circle.
	color := Color blue.! !

!PlotVertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 20:37'!
shape

	^shape! !

!PlotVertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 20:37'!
shape: aSymbol
	
	shape := aSymbol! !

Vertex subclass: #StateAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-StateMachine'!

StateAbstract subclass: #ProbableState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-Stochastic'!

!ProbableState classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:56'!
designatedEdgeClass

	^StochasticEdge! !

!ProbableState methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:55'!
for: transProbability give: output be: aProbableState

	(self connectTo: aProbableState)
		probability: transProbability;
		output: output! !

!ProbableState methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:55'!
normalizeConditionaryProbabilities

	|sum|
	sum := self sumOfConditionaryProbabilities.
	self leavingEdges do: [:edge | edge probability: (edge probability / sum)]! !

!ProbableState methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:55'!
stateEdgeFor: aNumber

	| dice |
	dice := aNumber.
	^self leavingEdges
		detect:
		[:edge|
		dice<= edge probability
			ifTrue:
			[true]
			ifFalse:
			[dice := dice - edge probability. false]]! !

!ProbableState methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:55'!
sumOfConditionaryProbabilities

	^self leavingEdges inject: 0 into: [:sum :edge| edge probability + sum ]! !

StateAbstract subclass: #State
	instanceVariableNames: 'inputToEdgeTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graph-StateMachine'!

!State classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 20:58'!
designatedEdgeClass

	^StateEdge! !

!State methodsFor: 'structuring' stamp: 'hjo 9/18/2009 20:56'!
for: input give: output be: aState

	(inputToEdgeTable
		at: input
		put: (self connectTo: aState)) output: output! !

!State methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 20:57'!
initialize

	super initialize.
	inputToEdgeTable := Dictionary new! !

!State methodsFor: 'querying' stamp: 'hjo 9/18/2009 20:57'!
stateEdgeFor: anObject

	^inputToEdgeTable at: anObject! !

!StateAbstract methodsFor: 'structuring' stamp: 'hjo 9/18/2009 20:50'!
for: input give: output be: aState

	self subclassResponsibility	! !

!StateAbstract methodsFor: 'querying' stamp: 'hjo 9/18/2009 20:51'!
nextStateFor: anObject

	^(self stateEdgeFor: anObject) terminalPoint! !

!StateAbstract methodsFor: 'querying' stamp: 'hjo 9/18/2009 20:51'!
outputFor: anObject

	^(self stateEdgeFor: anObject) output! !

!StateAbstract methodsFor: 'querying' stamp: 'hjo 9/18/2009 20:51'!
stateEdgeFor: anObject

	self subclassResponsibility! !

!Vertex classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 19:20'!
designatedEdgeClass

	^Edge! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 17:16'!
addAllEdges: aCollection

	aCollection do: [:edge| self addEdge: edge ]
	"self edges addAll: aCollection"! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:02'!
addEdge: anEdge

	(anEdge hasDirection)
		ifTrue:
		[ self == anEdge terminalPoint 
			ifTrue:
			[ enteringEdges add: anEdge ]
			ifFalse: 
			[ leavingEdges add: anEdge ]
		"There was a Korean comment here."
		]
		ifFalse:
		[ twoWayEdges add: anEdge ].
	"self edges add: anEdge"! !

!Vertex methodsFor: 'querying' stamp: 'hjo 9/18/2009 18:02'!
backNeighbors

	^self edgesThatCanEnter collect: [:edge| edge otherEndPointOf: self ]
! !

!Vertex methodsFor: 'visiting operation' stamp: 'hjo 9/20/2009 15:42'!
breadthFirstDoVertex: vertexBlock doEdge: edgeBlock

	| v |
	v := BreadthFirstGraphVisitor new.
	v currentVertices: (Array with: self).! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:02'!
connect: aVertex

	^self class designatedEdgeClass new connect: self and: aVertex! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
connectAll: aVertexCollection

	|newEdges|

	newEdges := OrderedCollection new.
	aVertexCollection do: [:vertex| newEdges add: (self connect: vertex) ].
	^newEdges! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
connectFrom: aVertex

	^self class designatedEdgeClass new connectFrom: aVertex to: self! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
connectFromAll: aVertexCollection

	|newEdges|
	newEdges := OrderedCollection new.
	aVertexCollection do: [:vertex| newEdges add: (self connectFrom: vertex) ].
	^newEdges! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
connectTo: aVertex

	^self class designatedEdgeClass new connectFrom: self to: aVertex! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
connectToAll: aVertexCollection

	|newEdges|
	newEdges := OrderedCollection new.
	aVertexCollection do: [:vertex| newEdges add: (self connectTo: vertex) ].
	^newEdges! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/18/2009 18:03'!
degree

	^self edges size! !

!Vertex methodsFor: 'printing' stamp: 'hjo 9/19/2009 17:50'!
detailPrintString

	|string|
	string := String empty.
	self revisit: 'model can give some descrption for me'.
	^string! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 18:03'!
disconnectTo: aVertex

	(self edgesConnecting: aVertex) do: [:edge| edge disconnect]! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 18:04'!
edges

	^(twoWayEdges union: enteringEdges) union: leavingEdges! !

!Vertex methodsFor: 'querying' stamp: 'hjo 9/18/2009 18:04'!
edgesConnecting: aVertex

	^self edges select: [:edge| edge connects: self and: aVertex ]! !

!Vertex methodsFor: 'querying' stamp: 'hjo 9/18/2009 18:27'!
edgesThatCanEnter

	^twoWayEdges union: enteringEdges! !

!Vertex methodsFor: 'querying' stamp: 'hjo 9/18/2009 18:27'!
edgesThatCanLeave

	^twoWayEdges union: leavingEdges! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 18:27'!
enteringEdges 

	^enteringEdges! !

!Vertex methodsFor: 'finalization' stamp: 'hjo 9/18/2009 18:27'!
finalize

	self edges do: [:edge| edge letGo: self ]! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/19/2009 19:00'!
hasEdge: anEdge 

	^self edges includes: anEdge! !

!Vertex methodsFor: 'initialize-release' stamp: 'hjo 9/18/2009 19:17'!
initialize

	super initialize.
	"self beFinalizable." "self toFinalizeSend: #finalize to: self with: nil."
	enteringEdges := Set new.
	leavingEdges := Set new.
	twoWayEdges := Set new! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/18/2009 19:18'!
isAdjacentWith: aVertex

	^self edges anySatisfy: [ :edge | edge connects: aVertex ]! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/18/2009 19:18'!
isConnectedTo: aVertex

	^self edges anySatisfy: 
		[:edge| edge connects: aVertex and: self ].! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/18/2009 19:18'!
isIsolatedVertex

	^self edges isEmpty! !

!Vertex methodsFor: 'testing' stamp: 'hjo 9/18/2009 19:18'!
isSelfConnected

	^self isConnectedTo: self! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:18'!
leavingEdges

	^leavingEdges! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/19/2009 18:39'!
masterObject

	^masterObject! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/19/2009 18:39'!
masterObject: anObject

	masterObject := anObject! !

!Vertex methodsFor: 'querying' stamp: 'hjo 9/18/2009 19:18'!
neighbors

	"OLD VERSION: ^self edges collect: [ :edge | edge otherEndPointOf: self ]"
	^self edgesThatCanLeave collect: [:edge| edge otherEndPointOf: self ]! !

!Vertex methodsFor: 'printing' stamp: 'hjo 9/18/2009 19:19'!
printOn: aStream

	|detail|
	super printOn: aStream.
	detail := self detailPrintString.
	detail size = 0 ifFalse: [aStream
					nextPut: $(;
					nextPutAll: detail;
					nextPut: $)].! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeAllEdges

	self
		removeAllEnteringEdges;
		removeAllLeavingEdges;
		removeAllTwoWayEdges! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeAllEnteringEdges

	enteringEdges do: [:edge| edge disconnect]! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeAllLeavingEdges

	leavingEdges do: [:edge| edge disconnect]! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeAllTwoWayEdges

	twoWayEdges do: [:edge| edge disconnect]! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeEdge: anEdge

	"CAUTION: #removeEdge: does not nilify Edge referencing to this vertex"
	"self edges remove: anEdge ifAbsent: [ self error: 'Can''t remove unexisting edge' ]"
	(anEdge hasDirection)
		ifTrue:
		[ self == anEdge terminalPoint 
			ifTrue:
			[ enteringEdges remove: anEdge ]
			ifFalse:
			[ leavingEdges remove: anEdge ] ]
		ifFalse:
		[ twoWayEdges remove: anEdge ].! !

!Vertex methodsFor: 'connecting' stamp: 'hjo 9/18/2009 19:19'!
removeEdges: anEdgeCollection

	anEdgeCollection do: [:edge | self removeEdge: edge ]! !

!Vertex methodsFor: 'accessing' stamp: 'hjo 9/18/2009 19:19'!
twoWayEdges

	^twoWayEdges! !
